


;
;///////////////////////////////////////////////////////////////////////////
;//                                                                       //
;//                                                                       //
;//                                                                       //
;//                      CUTVIEW  PROGRAM                                 //
;//                      Written by Arthur Flood  2/01/93                 //
;//                                                                       //
;//                      email address:   artflood@aol.com                //
;//                                                                       //
;//                                                                       //
;///////////////////////////////////////////////////////////////////////////
;







; CUTVIEW.LSP 
; -----------
; THIS IS A PROGRAM WHICH CAN BE USED TO CUT AND PASTE A SECTION OF AN
; AUTOCAD DRAWING INTO A SEPARATE VIEW OR LOCATION. THE PROGRAM ALLOWS 
; THE USER TO WINDOW AN AREA OF A DRAWING, WHICH IS THEN CUT OUT AND 
; REDRAWN INTO A NEW LOCATION. 






;  REVISED  
;
;  02-01-93   created cutview program
;  03-05-93   improved program performance and corrected minor problems
;  03-19-93   improved box pick routine 







(defun cutview  (/ p0 p1 p3 ppt x1 y1 x3 y3 xx yy)
(setq e1 nil e2 nil e3 nil e4 nil p1 nil p3 nil)
(setq exlist nil cirlist nil)
(setq mtrimcnt 1 pi2 (/ pi 2))
   (while (or (= p1 nil) (= p3 nil))
   (prompt "\n \nSelect Window of Cut View ...")
   (setq p1 (getpoint))
   (if (/= p1 nil) (setq p3 (getcorner p1)) )
   (prompt "\n \n")
   )
 (setq x1 (car p1) y1 (cadr p1))
 (setq x3 (car p3) y3 (cadr p3))
 (if (< x3 x1) (setq xx x1 x1 x3 x3 xx))
 (if (< y1 y3) (setq yy y1 y1 y3 y3 yy))
 (setq p1 (list x1 y1) p3 (list x3 y3)) 
(setq entpos1 (entlast))
(boxw p1 p3)
(prompt "\n \nCopy Window To ...")
(setq p0 (midpoint p1 p3))
(setq entpos (entlast))
(command "copy" e1 e2 e3 e4 "" p0 pause)
(setq e1 (entnext entpos) e2 (entnext e1) e3 (entnext e2) e4 (entnext e3))
(setq ee (ssadd)) (ssadd e1 ee)(ssadd e2 ee)(ssadd e3 ee)(ssadd e4 ee)
(prompt "\n \nWorking...")
(setq entpos (entlast))
(setq ppt (getvar "lastpoint"))
  (repeat 4
  (setq entpos1 (entnext entpos1))
  (entdel entpos1)
  )
(command "copy" "c" p1 p3 "" p0 ppt)
(cutview2)
(command "change" ee "" "p" "lt" "phantom" "")
)


(defun cutview2 (/ pt1 pt2 pt3 pt4 pt5 pt6 pt7 pt8)
(setq pt1 (inters2 e1 e2) pt2 (inters2 e2 e3))
(setq pt3 (inters2 e3 e4) pt4 (inters2 e4 e1))
(setq pt5 (polar pt4 (dtr 135) 0.001))
(setq pt6 (polar pt1 (dtr  45) 0.002))
(setq pt6a (polar pt1 (dtr  45) 0.250))
(setq pt7 (polar pt2 (dtr 315) 0.001))
(setq pt8 (polar pt3 (dtr 225) 0.002))
(setq pt8a (polar pt3 (dtr 225) 0.250))
(setq adjust 0)
(mtrim e3 pt7 pt8) 
(setq adjust (/ pi 2))
(mtrim e2 pt6 pt7)
(setq adjust 0)
(mtrim e1 pt5 pt6)
(setq adjust (/ pi 2))
(mtrim e4 pt8 pt5)  
(rmextra pt1 pt3)
(erasess pt5 pt6a pt7 pt8a e1 e2 e3 e4 pt3 pt1)
)


(defun mtrim (line1 pnt1 pnt2 / ls ix name)
(setq sa (ssget "c" pnt1 pnt2)) 
(while (= (explodea pnt1 pnt2) 1))

(if (/= sa nil) (progn
(setq ls (sslength sa) ix 0)
(command "trim" line1 "")
  (repeat ls
  (setq name (ssname sa ix))
     (if (findangle name)
     (command (list name pnt2))
     (command (list name pnt1))
     )
  (setq ix (1+ ix))
  ) 
(command "")
(prin1) 
))
(if (or cirlist) (mtrim2 line1 cirlist pnt1 pnt2))
(setq sa nil cirlist nil)
)

(defun mtrim2 (e0 cirlist pnt1 pnt2 / ls ix name)
  (if (or (= mtrimcnt 1) (= mtrimcnt 3)) 
  (setq pntt pnt1) 
  (setq pntt pnt2)
  )
(setq ls (length cirlist) ix 0)
(command "trim" ee  "")
  (repeat ls
  (setq name (nth ix cirlist))
     (setq pntt (getcirpt name mtrimcnt)) 
  (command (list name pntt))
  (setq ix (1+ ix))
  ) 
(command "")
(prin1) 
(setq mtrimcnt (1+ mtrimcnt))
)
 

(defun explodea (p1 p2 / ax rr x1 x2 ix ls ee)  
(prompt "\nSearching for blocks\n \n")
(prompt "One Moment Please....")
(setq ax nil ix 0 rr 0 ls 0)
(if (/= sa nil) (setq ls (sslength sa)) )
  (repeat ls
  (setq x1 (getassoc 0 (ssname sa ix))) 
    (if (= x1 "INSERT")  (progn            
    (setq x2 (getassoc -1 (ssname sa ix)))
       (if (not (member x2 exlist)) 
       (setq ax (append ax (list x2)) rr 1)
       )
    ))
  (setq ix (1+ ix))
  )
(setq ix 0)
  (if (= rr 1) (progn
  (prompt "\n \nExploding blocks....")
  (prompt "\n \nNumber of blocks:  ")(princ (length ax)) 
    (repeat (length ax)
    (setq ee (nth ix ax))
    (command "explode" ee "")
    (setq exlist (append exlist (list ee)))
    (setq ix (1+ ix))
    )
  (setq sa (ssget "c" p1 p2)) 
  ))
(setq rr rr)
)


(defun rmextra (p1 p2 / x)
(prompt "\n \n \nRemoving fragments of exploded blocks ....")
(setq ss (ssget "w" p1 p2))
(setq x (entnext entpos))
   (while (/= x nil)
     (if  (not (ssmemb x ss) ) 
     (entdel x)
     )
   (setq x (entnext x))
   )
)


(defun boxw (pt1 pt3 / dx dy pt2 pt4)
(setq pt2 (list (car pt3) (cadr pt1)))
(setq pt4 (list (car pt1) (cadr pt3)))
(command "line" pt1 pt2 "")(setq e1 (entlast))
(command "line" pt2 pt3 "")(setq e2 (entlast))
(command "line" pt3 pt4 "")(setq e3 (entlast))
(command "line" pt4 pt1 "")(setq e4 (entlast))
)


(defun movept (pt1 x y / )
(setq pt1   (list  (+ (car pt1) x )  (+ (cadr pt1) y ) ) )
)


(defun midpoint (pt1 pt2 / x y pt3 ) 
  (setq x (+ (car pt1) (car pt2)))   (setq x (/ x 2))
  (setq y (+ (cadr pt1) (cadr pt2))) (setq y (/ y 2))
  (setq pt3 (list x y)) 
)


(defun getassoc ( x e / )
(cdr (assoc x (entget e)))
)


(defun dtr (a)
(* pi (/ a 180.0))
)


(defun inters2 (ea eb)
(inters (gpoint1 ea) (gpoint2 ea) (gpoint1 eb) (gpoint2 eb) nil)
)


(defun gpoint1 (a / xx)
(setq xx (entget a))
(cdr (assoc 10 xx))
)


(defun gpoint2 (a / xx)
(setq xx (entget a))
(cdr (assoc 11 xx))
)


(defun findangle (e / a i ang x)
(setq a (entget e) ang 0)
(setq i (cdr(assoc 0 a)))
   (if (= i "CIRCLE")  
     (setq cirlist (append (list e) cirlist))
   )
   (if (= i "LINE") 
     (setq ang (angle (cdr(assoc 10 a)) (cdr(assoc 11 a))) )
   )
(setq ang (- ang adjust))
(if (< ang 0)  (setq ang (+ ang pi)) )
(if (> ang pi) (setq ang (- ang pi)) )
(if (< ang pi2) (setq x 1) (setq x nil))
)


(defun getcirpt (ex cnt / a)
(setq a (entget ex))
(setq ptc (cdr (assoc 10 a)))
(setq rad (cdr (assoc 40 a)))
(setq ang (- (* cnt pi2) pi))
(polar ptc ang rad)
)


(defun c:test1 ()
(c:cutview)
)


(defun c:cutview ()
(setvar "cmdecho" 0)
(command "osnap" "off")
(command "ortho" "off")
(command "ucs" "w") 
(cutview)
(setq entpos nil)
(command "ucs" "p")
(setvar "cmdecho" 1)
(prompt "\n \n \n")
(princ)
)


(defun erasess (pt5 pt6a pt7 pt8a ee1 ee2 ee3 ee4 p1 p3 /)
(setq x1 (car p1) x2 (car p3) y1 (cadr p1) y2 (cadr p3))
(setq eraselist (ssadd))
(setq ss1 (ssget "W" pt7 pt8a)) 
(setq ss2 (ssget "W" pt6a pt7)) 
(setq ss3 (ssget "W" pt5 pt6a)) 
(setq ss4 (ssget "W" pt8a pt5)) 
(erasess2 ss1 ee3) 
(erasess2 ss2 ee2)
(erasess2 ss3 ee1)
(erasess2 ss4 ee4)
)


(defun erasess2 (sss eee /)
   (setq ix 0)
   (repeat (sslength sss)
   (setq name (ssname sss ix))
     (if (and  (not (eq name eee))  (outside name)  )   
        (progn
        (ssadd name eraselist)
        )
     )
   (setq ix (1+ ix))
   )
(command "erase" eraselist "")
)


(defun outside (name / x en nn)
(setq tt (entget name) x nil)
(setq nn (cdr(assoc 0 tt)))
  (if (= nn "LINE") (progn
  (setq pt (cdr(assoc 10 tt)))
  (setq x0 (car pt) y0 (cadr pt))
    (if (or (< x0 x1) (> x0 x2) (< y0 y1) (> y0 y2))
    (setq x 1)
    )
  ))

  (if (= nn "ARC") (progn
  (setq pt0 (cdr(assoc 10 tt)))
  (setq rad (cdr(assoc 40 tt)))
  (setq aa1 (cdr(assoc 50 tt)))
  (setq aa2 (cdr(assoc 51 tt)))
  (setq aa0 (/ (+ aa1 aa2) 2))
  (if (> aa1 aa2) (setq aa0 (+ aa0 pi)) )
  (setq pt (polar pt0 aa0 rad))
  (setq x0 (car pt) y0 (cadr pt))
    (if (or (< x0 x1) (> x0 x2) (< y0 y1) (> y0 y2))
    (setq x 1)
    )
  ))

(setq x x)
)



