
(prompt "\n DWGSCR.lsp -- Convert drawing into script file which then can be run")
(prompt "\n               under newer verion of AutoCAD")
(prompt "\n")
(prompt "\nwritten by Omar Melo of SeCAD Miami FL 33165 (800) 777-3223")
(prompt "\n")
;
;    Please note that this version does not set the colors or 
;    linetype of layer. It could use more work but it more than
;    reduing the drawing. Block are wblock out and you will need 
;    to run this routine in those drawing too. If you are runing
;    this for 2.18 or earlier you will need to adjust how the 
;    layer command is use. Polyline and hatch pattern will be exploded 
;    automaticly (if you don't care about drawing size you may do this to
;    the blocks too). May this solve your problems come upgrade time.
;
;
(setq e  (entnext)
      fn (open (strcat (getvar "dwgname") ".scr") "w")
      lo ""
)

(setq f (getvar "extmin")
      f (strcat (rtos (car f) 2 6) "," (rtos (last f) 2 6))
      t (getvar "extmax")
      t (strcat (rtos (car t) 2 6) "," (rtos (last t) 2 6))
      b (getvar "insbase")
      b (strcat (rtos (car b) 2 6) "," (rtos (last b) 2 6))
)

(write-line (strcat "limits " f " " t) fn)
(write-line (strcat "base " b) fn)
(write-line (strcat "zoom w " f " " t) fn)
(write-line (strcat "blipmode off") fn)


(while e
       (setq ent (entget e)
             la  (cdr (assoc 8 ent))
             tp  (cdr (assoc 0 ent))
       )
       (if (/= la lo)
           (progn (setq lo la)
                  (write-line (strcat "layer m " la " ") fn) 
;                  (write-line (strcat "layer n " la " s " la " ") fn) ; replace this line with above line for version 2.18 or earlier

           )
       )
       (cond ((= tp "LINE")
              (progn (setq f (cdr (assoc 10 ent))
                           f (strcat (rtos (car f) 2 6) "," (rtos (last f) 2 6))
                           t (cdr (assoc 11 ent))
                           t (strcat (rtos (car t) 2 6) "," (rtos (last t) 2 6))
                     )
                     (write-line (strcat "line " f " " t " ") fn)
              )
             )
             ((= tp "ARC")
              (progn (setq c (cdr (assoc 10 ent))
                           f (polar c (cdr (assoc 50 ent)) (cdr (assoc 40 ent)))
                           f (strcat (rtos (car f) 2 6) "," (rtos (last f) 2 6))
                           t (polar c (cdr (assoc 51 ent)) (cdr (assoc 40 ent)))
                           t (strcat (rtos (car t) 2 6) "," (rtos (last t) 2 6))
                           c (strcat (rtos (car c) 2 6) "," (rtos (last c) 2 6))
                     )
                     (write-line (strcat "arc c " c " " f " " t) fn)
              )
             )
             ((= tp "CIRCLE")
              (progn (setq f (cdr (assoc 10 ent))
                           f (strcat (rtos (car f) 2 6) "," (rtos (last f) 2 6))
                           t (rtos (cdr (assoc 40 ent)) 2 6)
                     )
                     (write-line (strcat "circle " f " " t ) fn)
              )
             )
             ((= tp "INSERT")
              (progn (setq n (cdr (assoc 2 ent))
                           a (angtos (cdr (assoc 50 ent)) 0 6)
                           f (cdr (assoc 10 ent))
                           f (strcat (rtos (car f) 2 6) "," (rtos (last f) 2 6))
                           x (rtos (cdr (assoc 41 ent)) 2 6)
                           y (rtos (cdr (assoc 42 ent)) 2 6)
                     )
                     (if (= (substr n 1 2) "*X")
                         (command "explode" e)
                         (progn (setq bl (open (strcat n ".dwg") "r"))
                                (if bl
                                    (close bl)
                                    (command "wblock" n "=")
                                )
                                (write-line (strcat "insert " n " " f " " x " " y " " a) fn)
                         )
                     )
              )
             )
             ((= tp "SOLID")
              (progn (setq a (cdr (assoc 10 ent))
                           a (strcat (rtos (car a) 2 6) "," (rtos (last a) 2 6))
                           b (cdr (assoc 11 ent))
                           b (strcat (rtos (car b) 2 6) "," (rtos (last b) 2 6))
                           c (cdr (assoc 12 ent))
                           c (strcat (rtos (car c) 2 6) "," (rtos (last c) 2 6))
                           d (cdr (assoc 13 ent))
                           d (strcat (rtos (car d) 2 6) "," (rtos (last d) 2 6))


                     )
                     (write-line (strcat "solid " a " " b " " c " " d " ") fn)
              )
             )
             ((or (= tp "POLYLINE") (= tp "DIMENSION"))
              (command "explode" e)
             )
             ((= tp "TEXT")
              (progn (setq h (rtos   (cdr (assoc 40 ent)) 2 6)
                           a (angtos (cdr (assoc 50 ent)) 0 6)
                           m (cdr (assoc 72 ent))
                           f (cdr (assoc 10 ent))
                           f (strcat (rtos (car f) 2 6) "," (rtos (last f) 2 6))
                           t (cdr (assoc 11 ent))
                           t (strcat (rtos (car t) 2 6) "," (rtos (last t) 2 6))
                           txt (cdr (assoc 1 ent))
                      )
                      (cond ((= m 0) (write-line (strcat "text " f " " h " " a " " txt) fn))
                            ((= m 1) (write-line (strcat "text c " t " " h " " a " " txt) fn))
                            ((= m 2) (write-line (strcat "text r " t " " h " " a " " txt) fn))
                            ((= m 4) (write-line (strcat "text m " t " " h " " a " " txt) fn))
                            ((= m 5) (write-line (strcat "text f " f " " t " " h " " txt) fn))
                            ((= m 3) (write-line (strcat "text a " f " " t " " txt) fn))
                      )
              )
             )
       )
       (setq e (entnext e))
)
(write-line "zoom e" fn)
(close fn)

; PS. Battiers not included
