;Geometric Tolerancing to B.S. 308

(setq OPTION 1)
(setq HEIGHT (getvar "TEXTSIZE"))
(setq MAXIM "N")
(setq PREFIX "N")
(setq DAT "A")
(setq TOLER 0.0)
(setq NUM 9)
(setq SPECIFIC "N")
(setq SPECLEN 100)
(setq CONT "N")

(vmon)

(defun check ()
       (if (/= getvar "TEXTSTYLE") "GTOLTXT")
          (progn
              (princ "\n\nThe current textstyle is ")
              (princ (getvar "TEXTSTYLE"))
              (princ ". Please ensure GTOLTXT is Loaded \n")
              (getstring "Hit Spacebar or Return to continue)
          )
       )
)

(defun MENU()
       (textscr)
       (command "cls")
       (princ "          G T O L\n")
       (princ "Version 1.10 IBM PC\n")
       (princ "Autocad Serial Number: ")
       (princ (getvar "_pkser"))
       (terpri)
       (princ (ver))
       (princ "\n\nGeometric tolerancing Menu\n\n")
       (princ "  0....Exit GtoL\n)
       (princ "  1....Straightness\n")
       (princ "  2....Flatness\n")
       (princ "  3....Roundness\n")
       (princ "  4....Cylindricity\n")
       (princ "  5....Profile of a Line\n")
       (princ "  6....Profile of a Surface\n")
       (princ "  7....Parallelism\n")
       (princ "  8....Squareness\n")
       (princ "  9....Angularity\n")
       (princ "  10...Position\n")
       (princ "  11...Concentricity\n")
       (princ "  12...Symmetry\n")
       (princ "  13...Run-out\n\n")
       (setq OPTION   (INPUT_INTEGER "Enter option" OPTION))
)

(defun INPUT_STRING(A B D / C)
       (setq A (strcat A " <" B ">" "))
       (setq C (substr (getstring A)  1 D))
       (if (/= C "")
           (setq B C)
           (setq B B)
       )
)

(swdun INPUT_INTEGER(A B / C)
       (setq A (strcat A " <" (itoa B) ">: "))
       (setq C (getint A))
       (if (/= C nil)
           (setq B C)
           (setq B B)
      )
)

(defun YES_OR_NO(A B C)
       (if (= (strcase A) "Y")
           (setq B C)
           (setq B "")
      )
)

(defun INPUT()
   (setq HEIGHT   (INPUT_REAL "Enter text height" HEIGHT))
   (setq PREFIX   (INPUT_STRING "Prefix Tolerance with diameter sign (y/n)"
                                PREFIX))
   (setq TOLER    (INPUT_REAL "Enter Tolerance value" TOLER))
   (setq MAXIM    (INPUT_STRING "Maximum material condition (y/n)" MAXIM 1))
   (setq SPECIFIC (INPUT_STRING "Specific Length (y/n)" SPECIFIC 1))
   (setq DIA_SIGN (YES_OR_NO PREFIX DIA_SIGN "\201"))
   (setq MAX_SIGN (YES_OR_NO MAXIM MAX_SIGN "\217"))
   (setq OPTION_STRING (chr (+ OPTION 129)))
   (setq TOLERANCE (strcat OPTION_STRING " " DIA_SIGN
                           (rtos TOLER) MAX_SIGN))
(if (= (strcase SPECIFIC( "Y")
    (progn
          (setq SPECLEN (INPUT_INTEGER "Enter Specific Length" SPECLEN))
          (setq TOLERANCE (strcat TOLERANCE "/" (itoa SPECLEN)))
    )
)

(setq NUM       (INPUT_INTEGER "Enter Number of Datums" NUM))
(setq DATUMS "")
(setq COUNT 0)
(while (> NUM COUNT)
       (setq DAT       (INPUT_STRING "Enter Datum Letter(s)" DAT 4))
       (setq MAXIM     (INPUT_STRING "Maximum material condition (y/n)"
                                     (MAXIM 1))
       (setq MAX_SIGN  (YES_OR_NO MAXIM MAX_SIGN "\217"))
       (setq DATUMS    (strcat DATUMS " " DAT MAX_SIGN))
       (setq COUNT     (1+ COUNT))
)
(graphscr)
(setq TOLERANCE     (strcat TOLERANCE DATUMS))
(setq LENGTH_OF_TOL (strlen TOLERANCE))
(setq LEADER_START  (getpoint "leader start: "))
(setq LEADER_MID    (getpoint "LEADER_START "Text position: "))
(setq LEADER_END    (list (+ (car LEADER_MID) HEIGHT) (C\cadr LEADER_MID)))
(setq TEXT_POS      (list (+ (car LEADER_MID) (* HEIGHT 1.5))
                          (- (cadr LEADER_MID) (* HEIGHT 0.5))))
(setq BOX_CORNER    (list (- (car TEXT_POS) (* HEIGHT 0.5))
                          (- (cadr TEXT_POS) (* HEIGHT 0.5))))
   (setq DATUM_START  (list (+ (car LEADER_END)
                            (* (+ LENGTH_OF_TOL 1) HEIGHT))
                               (cadr LEADER_END)))
)

(defun DINPUT()
   (setq HEIGHT   (INPUT_REAL